/*
EntryPoints

## Overview  EntryPoint is one of the ways to start interaction flow. It can be represented as QR code, link (https://slace.me/... URL) or NFC tag.  ## Data  EntryPoints contain two types of data:   - **static** - *\"internal\" data storage which can be updated only via editing the EntryPoint* (directly or via Interaction) - **dynamic** - *public data which can be altered also via query parameters of the EP link. Should NOT be used for secrets or critical data* because it can be overwritten by the end user.  Both data containers are copied to transaction created when EntryPoint is entered. This data is used primarily for personalization or flow control of the Interaction.  ## EP Batches  EntryPoints can be batch-created (superadmin feature) and then [assigned](https://slace.stoplight.io/docs/stoplight-docs-core/altekzonwbrq9-imports-uploads#assignment-xlsx) to specific Interactions.  > EntryPoints in a batch have random hashes but it's possible to mass-create EPs using the assignment feature (only superadmins). If a value from **Link hash** column is not found it will be auto-created. This allows to create EntryPoints following different hash pattern (e.g. with common prefix).  EntryPoints are re-assignable meaning that they can be re-used for other Interactions even in another Channel or Organization by another [assignment import](https://slace.stoplight.io/docs/stoplight-docs-core/altekzonwbrq9-imports-uploads#assignment-xlsx).  ## Redirects  There is a special type of EntryPoint which does not start a SLACE Interaction but redirects to a configured URL.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package entrypoints

import (
	"encoding/json"
)

// checks if the EntryPointData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &EntryPointData{}

// EntryPointData Either `message_link_hash`, `interaction_id`, `customer_experience_id` or `redirect_url` is required.  When `type` not provided default `link` type will be used.
type EntryPointData struct {
	Type *EntryPointType `json:"type,omitempty"`
	// Custom identifier to create user friendly urls. If provided has to be unique globally. If not set unique id will be generated.
	Hash *string `json:"hash,omitempty"`
	MessageLinkHash *string `json:"message_link_hash,omitempty"`
	InteractionId *string `json:"interaction_id,omitempty"`
	// Some external url for which short link will be created
	RedirectUrl *string `json:"redirect_url,omitempty"`
	// Optional url to which entry point will redirect when expired
	ExpiredUrl *string `json:"expired_url,omitempty"`
	// Time to live in seconds
	Ttl *int32 `json:"ttl,omitempty"`
	// Dynamic data ius similar to static_data but it can be also overwritten by url query parameters. This structure is then copied to contact transaction related to entry point (for example after QR code scan)
	DynamicData *map[string]string `json:"dynamic_data,omitempty"`
	// Custom data attached to entry point. This data is copied to every transaction when user scans and interacts messenger.
	StaticData *map[string]string `json:"static_data,omitempty"`
	// Any text without '.' characters. Preferred over interaction_id if keeping the reference to the latest version of interaction is required.
	CustomerExperienceId *string `json:"customer_experience_id,omitempty"`
	ChannelId *string `json:"channel_id,omitempty"`
}

// NewEntryPointData instantiates a new EntryPointData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewEntryPointData() *EntryPointData {
	this := EntryPointData{}
	return &this
}

// NewEntryPointDataWithDefaults instantiates a new EntryPointData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewEntryPointDataWithDefaults() *EntryPointData {
	this := EntryPointData{}
	return &this
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *EntryPointData) GetType() EntryPointType {
	if o == nil || IsNil(o.Type) {
		var ret EntryPointType
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EntryPointData) GetTypeOk() (*EntryPointType, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *EntryPointData) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given EntryPointType and assigns it to the Type field.
func (o *EntryPointData) SetType(v EntryPointType) {
	o.Type = &v
}

// GetHash returns the Hash field value if set, zero value otherwise.
func (o *EntryPointData) GetHash() string {
	if o == nil || IsNil(o.Hash) {
		var ret string
		return ret
	}
	return *o.Hash
}

// GetHashOk returns a tuple with the Hash field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EntryPointData) GetHashOk() (*string, bool) {
	if o == nil || IsNil(o.Hash) {
		return nil, false
	}
	return o.Hash, true
}

// HasHash returns a boolean if a field has been set.
func (o *EntryPointData) HasHash() bool {
	if o != nil && !IsNil(o.Hash) {
		return true
	}

	return false
}

// SetHash gets a reference to the given string and assigns it to the Hash field.
func (o *EntryPointData) SetHash(v string) {
	o.Hash = &v
}

// GetMessageLinkHash returns the MessageLinkHash field value if set, zero value otherwise.
func (o *EntryPointData) GetMessageLinkHash() string {
	if o == nil || IsNil(o.MessageLinkHash) {
		var ret string
		return ret
	}
	return *o.MessageLinkHash
}

// GetMessageLinkHashOk returns a tuple with the MessageLinkHash field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EntryPointData) GetMessageLinkHashOk() (*string, bool) {
	if o == nil || IsNil(o.MessageLinkHash) {
		return nil, false
	}
	return o.MessageLinkHash, true
}

// HasMessageLinkHash returns a boolean if a field has been set.
func (o *EntryPointData) HasMessageLinkHash() bool {
	if o != nil && !IsNil(o.MessageLinkHash) {
		return true
	}

	return false
}

// SetMessageLinkHash gets a reference to the given string and assigns it to the MessageLinkHash field.
func (o *EntryPointData) SetMessageLinkHash(v string) {
	o.MessageLinkHash = &v
}

// GetInteractionId returns the InteractionId field value if set, zero value otherwise.
func (o *EntryPointData) GetInteractionId() string {
	if o == nil || IsNil(o.InteractionId) {
		var ret string
		return ret
	}
	return *o.InteractionId
}

// GetInteractionIdOk returns a tuple with the InteractionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EntryPointData) GetInteractionIdOk() (*string, bool) {
	if o == nil || IsNil(o.InteractionId) {
		return nil, false
	}
	return o.InteractionId, true
}

// HasInteractionId returns a boolean if a field has been set.
func (o *EntryPointData) HasInteractionId() bool {
	if o != nil && !IsNil(o.InteractionId) {
		return true
	}

	return false
}

// SetInteractionId gets a reference to the given string and assigns it to the InteractionId field.
func (o *EntryPointData) SetInteractionId(v string) {
	o.InteractionId = &v
}

// GetRedirectUrl returns the RedirectUrl field value if set, zero value otherwise.
func (o *EntryPointData) GetRedirectUrl() string {
	if o == nil || IsNil(o.RedirectUrl) {
		var ret string
		return ret
	}
	return *o.RedirectUrl
}

// GetRedirectUrlOk returns a tuple with the RedirectUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EntryPointData) GetRedirectUrlOk() (*string, bool) {
	if o == nil || IsNil(o.RedirectUrl) {
		return nil, false
	}
	return o.RedirectUrl, true
}

// HasRedirectUrl returns a boolean if a field has been set.
func (o *EntryPointData) HasRedirectUrl() bool {
	if o != nil && !IsNil(o.RedirectUrl) {
		return true
	}

	return false
}

// SetRedirectUrl gets a reference to the given string and assigns it to the RedirectUrl field.
func (o *EntryPointData) SetRedirectUrl(v string) {
	o.RedirectUrl = &v
}

// GetExpiredUrl returns the ExpiredUrl field value if set, zero value otherwise.
func (o *EntryPointData) GetExpiredUrl() string {
	if o == nil || IsNil(o.ExpiredUrl) {
		var ret string
		return ret
	}
	return *o.ExpiredUrl
}

// GetExpiredUrlOk returns a tuple with the ExpiredUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EntryPointData) GetExpiredUrlOk() (*string, bool) {
	if o == nil || IsNil(o.ExpiredUrl) {
		return nil, false
	}
	return o.ExpiredUrl, true
}

// HasExpiredUrl returns a boolean if a field has been set.
func (o *EntryPointData) HasExpiredUrl() bool {
	if o != nil && !IsNil(o.ExpiredUrl) {
		return true
	}

	return false
}

// SetExpiredUrl gets a reference to the given string and assigns it to the ExpiredUrl field.
func (o *EntryPointData) SetExpiredUrl(v string) {
	o.ExpiredUrl = &v
}

// GetTtl returns the Ttl field value if set, zero value otherwise.
func (o *EntryPointData) GetTtl() int32 {
	if o == nil || IsNil(o.Ttl) {
		var ret int32
		return ret
	}
	return *o.Ttl
}

// GetTtlOk returns a tuple with the Ttl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EntryPointData) GetTtlOk() (*int32, bool) {
	if o == nil || IsNil(o.Ttl) {
		return nil, false
	}
	return o.Ttl, true
}

// HasTtl returns a boolean if a field has been set.
func (o *EntryPointData) HasTtl() bool {
	if o != nil && !IsNil(o.Ttl) {
		return true
	}

	return false
}

// SetTtl gets a reference to the given int32 and assigns it to the Ttl field.
func (o *EntryPointData) SetTtl(v int32) {
	o.Ttl = &v
}

// GetDynamicData returns the DynamicData field value if set, zero value otherwise.
func (o *EntryPointData) GetDynamicData() map[string]string {
	if o == nil || IsNil(o.DynamicData) {
		var ret map[string]string
		return ret
	}
	return *o.DynamicData
}

// GetDynamicDataOk returns a tuple with the DynamicData field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EntryPointData) GetDynamicDataOk() (*map[string]string, bool) {
	if o == nil || IsNil(o.DynamicData) {
		return nil, false
	}
	return o.DynamicData, true
}

// HasDynamicData returns a boolean if a field has been set.
func (o *EntryPointData) HasDynamicData() bool {
	if o != nil && !IsNil(o.DynamicData) {
		return true
	}

	return false
}

// SetDynamicData gets a reference to the given map[string]string and assigns it to the DynamicData field.
func (o *EntryPointData) SetDynamicData(v map[string]string) {
	o.DynamicData = &v
}

// GetStaticData returns the StaticData field value if set, zero value otherwise.
func (o *EntryPointData) GetStaticData() map[string]string {
	if o == nil || IsNil(o.StaticData) {
		var ret map[string]string
		return ret
	}
	return *o.StaticData
}

// GetStaticDataOk returns a tuple with the StaticData field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EntryPointData) GetStaticDataOk() (*map[string]string, bool) {
	if o == nil || IsNil(o.StaticData) {
		return nil, false
	}
	return o.StaticData, true
}

// HasStaticData returns a boolean if a field has been set.
func (o *EntryPointData) HasStaticData() bool {
	if o != nil && !IsNil(o.StaticData) {
		return true
	}

	return false
}

// SetStaticData gets a reference to the given map[string]string and assigns it to the StaticData field.
func (o *EntryPointData) SetStaticData(v map[string]string) {
	o.StaticData = &v
}

// GetCustomerExperienceId returns the CustomerExperienceId field value if set, zero value otherwise.
func (o *EntryPointData) GetCustomerExperienceId() string {
	if o == nil || IsNil(o.CustomerExperienceId) {
		var ret string
		return ret
	}
	return *o.CustomerExperienceId
}

// GetCustomerExperienceIdOk returns a tuple with the CustomerExperienceId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EntryPointData) GetCustomerExperienceIdOk() (*string, bool) {
	if o == nil || IsNil(o.CustomerExperienceId) {
		return nil, false
	}
	return o.CustomerExperienceId, true
}

// HasCustomerExperienceId returns a boolean if a field has been set.
func (o *EntryPointData) HasCustomerExperienceId() bool {
	if o != nil && !IsNil(o.CustomerExperienceId) {
		return true
	}

	return false
}

// SetCustomerExperienceId gets a reference to the given string and assigns it to the CustomerExperienceId field.
func (o *EntryPointData) SetCustomerExperienceId(v string) {
	o.CustomerExperienceId = &v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *EntryPointData) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EntryPointData) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *EntryPointData) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *EntryPointData) SetChannelId(v string) {
	o.ChannelId = &v
}

func (o EntryPointData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o EntryPointData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.Hash) {
		toSerialize["hash"] = o.Hash
	}
	if !IsNil(o.MessageLinkHash) {
		toSerialize["message_link_hash"] = o.MessageLinkHash
	}
	if !IsNil(o.InteractionId) {
		toSerialize["interaction_id"] = o.InteractionId
	}
	if !IsNil(o.RedirectUrl) {
		toSerialize["redirect_url"] = o.RedirectUrl
	}
	if !IsNil(o.ExpiredUrl) {
		toSerialize["expired_url"] = o.ExpiredUrl
	}
	if !IsNil(o.Ttl) {
		toSerialize["ttl"] = o.Ttl
	}
	if !IsNil(o.DynamicData) {
		toSerialize["dynamic_data"] = o.DynamicData
	}
	if !IsNil(o.StaticData) {
		toSerialize["static_data"] = o.StaticData
	}
	if !IsNil(o.CustomerExperienceId) {
		toSerialize["customer_experience_id"] = o.CustomerExperienceId
	}
	if !IsNil(o.ChannelId) {
		toSerialize["channel_id"] = o.ChannelId
	}
	return toSerialize, nil
}

type NullableEntryPointData struct {
	value *EntryPointData
	isSet bool
}

func (v NullableEntryPointData) Get() *EntryPointData {
	return v.value
}

func (v *NullableEntryPointData) Set(val *EntryPointData) {
	v.value = val
	v.isSet = true
}

func (v NullableEntryPointData) IsSet() bool {
	return v.isSet
}

func (v *NullableEntryPointData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableEntryPointData(val *EntryPointData) *NullableEntryPointData {
	return &NullableEntryPointData{value: val, isSet: true}
}

func (v NullableEntryPointData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableEntryPointData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


